



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>php查询mysql中的json编码后的字符串内容的方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">php查询mysql中的json编码后的字符串内容的方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 23:12:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>问题</h3>
<ol><li>mysql里存的是json编码后的字符串，其中中文会被转为unicode码，所以直接查询是查询不到的。</li>
<li>mysql里的查询如 like "%\u6211\u662f%" 也是不会有结果的，原因是反斜线被mysql转义了， 需要如下的格式才能查询: like "%\\\\u6211\\\\u662f%" (四个反斜杠) 注意:mysql5.7版以后增加了直接对json格式的支持.</li></ol>
<h3>解决方式:</h3>
<p>1.写php函数对要查询的字符串进行unicode编码(这里，我们利用了json_encode这个函数)</p>
<div>
<pre class="prettyprint linenums">$keyword = '出票';<br />
$bb=json_encode(array($keyword));<br />
$str = preg_replace("/^\[\"|\"\]$/","",$bb);</pre>
</div>
<p>2.对转化成unicode后的字符串，替换为4个反斜杠.</p>
<div>
<pre class="prettyprint linenums">$keyword= str_replace("\\","\\\\",$str);<br />
var_dump($keyword);</pre>
</div>
<p>3.查询</p>
<div>
<pre class="prettyprint linenums">$res = DB::table('wx_push_logs')-&gt;where('data','like',"%{$keyword}%")-&gt;first();</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4w3r09.html">推荐一个学习golang的地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnk11gq.html">html、css杂记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zrvx59.html">Struts 1&period;3&lpar;第一例&rpar; - Login</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1nxrj8.html">使用NPOI完成导出Excel文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdy02d8.html">关于python中的unicode字符串的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z6dr09.html">Python算法之---冒泡，选择，插入排序算法</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vg2o38.html">14条Yahoo（雅虎）十四条优化原则【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1rrv38.html">c&num;读写共享内存操作函数封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pj3gv8.html">C&plus;&plus;对象的销毁</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zydm09.html">Android中ProgressDialog的应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey0k7x9.html">debug运行可以，release运行报错的原因及修改方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/950jp2m8.html">安装 MySQL 后，需要调整的 10 个性能配置项</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zdy4n9.html">spring aop &plus; xmemcached 配置service层缓存策略</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgwx7m8.html">MySQL优化五  SQL优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zop063q.html">Java知IO</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpwgnr9.html">&lbrack;Kubernetes&rsqb;yaml文件详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wyd3nq.html">没有upcast 也不会发生多态</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rm6nm9.html">获取Vue的实例方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1dg15q.html">前端开发之css</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyvmwv9.html">ie烦人的bug篇</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwvd7vl8.html">设计模式&amp;lt&semi;2&amp;gt&semi;------工厂模式和抽象工厂模式------创建型</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rm7wj9.html">C语言博客作业4--数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4yy7z9.html">objective-c数组的七种遍历方法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/960p02j9.html">python2&period;7 Cheetah  You don&amp;&num;39&semi;t have the C version of NameMapper installed</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rm22j9.html">pyinstaller 打包生成exe之后运行提示&OpenCurlyQuote;no module name &amp;&num;39&semi;xxx&amp;&num;39&semi;&rsquo;错误</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2ej62q.html">POI导入具有合并了单元格的Excel</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwp5jv9.html">asp&period;net ajax get 调用&lpar;和post不一样，直接返回json才行，否则报错；post不能返回json&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwdmzk8.html">Python module ---- os</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvj21k8.html">---Ubuntu 16&period;04 server 不能关机问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2elw0q.html">解析如何实现微信唤醒默认浏览器下载app教程！</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
